function varargout = Annotation(varargin)
% ANNOTATION M-file for Annotation.fig
%      ANNOTATION, by itself, creates a new ANNOTATION or raises the existing
%      singleton*.
%
%      H = ANNOTATION returns the handle to a new ANNOTATION or the handle to
%      the existing singleton*.
%
%      ANNOTATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ANNOTATION.M with the given input arguments.
%
%      ANNOTATION('Property','Value',...) creates a new ANNOTATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Annotation_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Annotation_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Annotation

% Last Modified by GUIDE v2.5 30-May-2011 20:22:20

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Annotation_OpeningFcn, ...
                   'gui_OutputFcn',  @Annotation_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% To prevent confusion
% handles.results(f).centerOD= center of macula
% handles.results(f).radius=radious of macula region 
% handles.results(f).ODborders = points chosen 





% --- Executes just before Annotation is made visible.
function Annotation_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Annotation (see VARARGIN)

% Choose default command line output for Annotation
handles.output = hObject;

% Display toolbar
set(hObject,'toolbar','figure');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Annotation wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Annotation_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% clear previous annotation data
handles.nameAnnotator=[];
handles.session=[];
handles.files = [];
handles.results = [];
handles.dateNtime =[];


% folder with images to process (initally the current directory)
handles.files.directory = pwd;
    
% number of image files to porcess
handles.files.nFiles = 0;

% display the Vampire logo
imageLogo=imread('eyeLogo.png');
axes(handles.mainFigure)
set(handles.mainFigure, 'NextPlot', 'ReplaceChildren')
imshow(imageLogo); 
axis fill

% display title of annotation tool 
c='Macula Annotation Tool';
set(handles.display,'String',c);

% key press event handling
set(handles.figure1,'KeyPressFcn',@KeyPress);


% set all buttons as off except Open folder
set(handles.OpenFolder,'Enable','on');
set(handles.ClearAll,'Enable','off');
set(handles.Next,'Enable','off');
set(handles.Finish,'Enable','off');


% updates handles
guidata( hObject, handles )


%% Get User Information ---------------------------------------------

function Name_Callback(hObject, eventdata, handles)
% hObject    handle to Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Name as text
%        str2double(get(hObject,'String')) returns contents of Name as a double
handles.nameAnnotator = get(hObject,'String');

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Session_Callback(hObject, eventdata, handles)
% hObject    handle to Session (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Session as text
%        str2double(get(hObject,'String')) returns contents of Session as a double
handles.session = str2num(get(hObject,'String'));

% Get the date 
dateNtime = datestr(now, '  dd mm yyyy HH.MM AM ');
handles.dateNtime=dateNtime;
guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.
function Session_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Session (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Start Annotation -------------------------------------------------

% --- Executes on button press in OpenFolder.
function OpenFolder_Callback(hObject, eventdata, handles)
% hObject    handle to OpenFolder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    % if the user information is not fully inputted, exit
    if isempty(handles.nameAnnotator )&&isempty(handles.session)
        uiwait(msgbox('Please enter User Name and Session')); 
        return;
    elseif isempty(handles.nameAnnotator)&&~isempty(handles.session)
        uiwait(msgbox('Please enter User Name')); 
        return;
    elseif ~isempty(handles.nameAnnotator) && isempty(handles.session)
        uiwait(msgbox('Please enter Session')); 
        return;        
    end
           
    
    % Set all buttons on 
    set(handles.ClearAll,'Enable','on');
    set(handles.Next,'Enable','on');
    set(handles.Finish,'Enable','on');
 
    % Get folder
    directory = uigetdir( handles.files.directory );
    
    % If the user pressed cancelled, then exit
    if directory == 0 
        return
    end
    
       
    % populate selectFiles_listbox and save handles
    handles = openFilesFromDirectory( directory, handles );    
    
    % initialize every image in the folder
    for f=1:handles.files.nFiles
        handles.results(f).centerOD=[];
        handles.results(f).radius=[];
        handles.results(f).ODborders =[];
    end

    % open image
    handles.imageID=1;
    handles.image = imread([ handles.files.directory filesep cell2mat(handles.files.name(handles.imageID)) ]); 
    [handles.imH,handles.imW]=size(handles.image);
    
    % updates handles
    guidata(hObject, handles);
    
    % plot image
    showImage ( handles );
  
    guidata(hObject, handles);
    
  
    
% --- Executes on mouse press over axes background.
function mainFigure_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to mainFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(gcbo);

% get points
p = get(handles.mainFigure, 'CurrentPoint');
point = p(1, [1 2]);

handles = ODannotation (handles,point);

     
% saves handles       
guidata(handles.output, handles);


    
% --- Executes on selection change in selectFiles_listbox.
function selectFiles_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to selectFiles_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns selectFiles_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from selectFiles_listbox

% % check process of current image before proceeding to other image
% CheckProcess( handles );

    % set image to show
    handles.imageID=get(hObject,'Value');
    guidata(hObject, handles);
    
    % open image
    handles.image = imread([ handles.files.directory filesep cell2mat(handles.files.name(handles.imageID)) ]); 
    [handles.imH,handles.imW]=size(handles.image);
     guidata(hObject, handles);

% check if annotation has been done for this image(user is allowed to go back to previous images and click next)

if isempty(handles.results(handles.imageID). ODborders)
    
% plot image
showImage ( handles );

else
    showImage ( handles );
    circle([handles.results(handles.imageID).centerOD(1),handles.results(handles.imageID).centerOD(2)],handles.results(handles.imageID).radius,100);
    p=plot(handles.results(handles.imageID).ODborders(1,1),handles.results(handles.imageID).ODborders(1,2),'b*');
    functionCall = @(hObject,eventdata)Annotation('mainFigure_ButtonDownFcn',hObject,eventdata,guidata(hObject));
    set(p,'ButtonDownFcn', functionCall );
end


guidata(hObject, handles)
    

% --- Executes during object creation, after setting all properties.
function selectFiles_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to selectFiles_listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Clear, Finish and Next Button ------------------------------------
% --- Executes on button press in ClearAll.
function ClearAll_Callback(hObject, eventdata, handles)
% hObject    handle to ClearAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%clear all results
handles.results(handles.imageID).centerOD=[];
handles.results(handles.imageID).radius=[];
handles.results(handles.imageID).ODborders =[];

guidata(hObject, handles);

% plot image
showImage ( handles );

% prompt user to start annotation again 
guidata(hObject, handles);


% --- Executes on button press in Finish.
function Finish_Callback(hObject, eventdata, handles)
% hObject    handle to Finish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 SaveAllResult( handles )



% --- Executes on button press in Next.
function Next_Callback(hObject, eventdata, handles)
% hObject    handle to Next (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% % check process of current image before proceeding to other image
% CheckProcess( handles );


% read the next image
handles.imageID=handles.imageID+1;
if handles.imageID > handles.files.nFiles
    c='All images have been annotated';
    set(handles.display,'String',c);
    return;
end

set(handles.selectFiles_listbox, 'String', handles.files.name, 'Value', handles.imageID)
% open image
handles.image = imread([ handles.files.directory filesep cell2mat(handles.files.name(handles.imageID)) ]); 
[handles.imH,handles.imW]=size(handles.image);
guidata(hObject, handles);
     
     
% check if annotation has been done for this image(user is allowed to go back to previous images and click next)

if isempty(handles.results(handles.imageID). ODborders)

% updates handles
guidata(hObject, handles);
    
% plot image
showImage ( handles );

else
    showImage ( handles );
    circle([handles.results(handles.imageID).centerOD(1),handles.results(handles.imageID).centerOD(2)],handles.results(handles.imageID).radius,100);
    p=plot(handles.results(handles.imageID).ODborders(1,1),handles.results(handles.imageID).ODborders(1,2),'b*');
    functionCall = @(hObject,eventdata)Annotation('mainFigure_ButtonDownFcn',hObject,eventdata,guidata(hObject));
    set(p,'ButtonDownFcn', functionCall );
end

guidata(hObject, handles)
