function  SaveAllResult( handles )
%SAVERESULT

%% Get directory 
timeStamp=strcat('GT','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime);
[file, dirName] = uiputfile(timeStamp, 'Save results');

if strcmp(file,timeStamp)
   
    fileName=strcat(file,'.xlsx');
else
   
    fileName=strcat(file, '_', timeStamp, '.xlsx');
end


%% Sheet 1 ----------------------------------------------------

% Create cell
Title={'MACULA ANNOTATION TOOL'};

AnnotatorInfo=cell(3,4);
AnnotatorInfo(1,1)={'Annotator:'};
AnnotatorInfo(1,2)={handles.nameAnnotator};
AnnotatorInfo(2,1)={'Date:'};
AnnotatorInfo(2,2)={handles.dateNtime};
AnnotatorInfo(3,1)={'Session:'};
AnnotatorInfo(3,2)={handles.session}; 

Name=cell(1,4);
Name(1,1)={'ImageName'}; 
Name(1,2)={'CenterX'};
Name(1,3)={'CenterY'};
Name(1,4)={'Radius'};


%Get ImageName,ImageAssess,Comment,EllipseParameter,Residual structure
ImageStructure=cell(handles.files.nFiles+6,4);
ImageStructure(1,1)=Title;
ImageStructure(2,:)=AnnotatorInfo(1,:);
ImageStructure(3,:)=AnnotatorInfo(2,:);
ImageStructure(4,:)=AnnotatorInfo(3,:);

ImageStructure(6,:)=Name;

for imageID=1:handles.files.nFiles           
    ImageStructure(imageID+6,1)=handles.files.name(imageID);
   
    if ~isempty(handles.results(imageID).centerOD)        
    ImageStructure(imageID+6,2)=num2cell(handles.results(imageID).centerOD(1));
    ImageStructure(imageID+6,3)=num2cell(handles.results(imageID).centerOD(2));
    end
    
    if ~isempty(handles.results(imageID).radius)
    ImageStructure(imageID+6,4)=num2cell(handles.results(imageID).radius);
    end
    
    if isempty(handles.results(imageID).centerOD) && isempty(handles.results(imageID).radius)
         ImageStructure(imageID+6,2:end)={''};
    end
      

end


% save data
xlswrite(strcat(dirName,'\',fileName),ImageStructure);





%close all;


