function circle(center,Oriradius,NOP,style)
%---------------------------------------------------------------------------------------------
% H=CIRCLE(CENTER,RADIUS,NOP,STYLE)
% This routine draws a circle with center defined as
% a vector CENTER, radius as a scaler RADIS. NOP is 
% the number of points on the circle. As to STYLE,
% use it the same way as you use the rountine PLOT.
% Since the handle of the object is returned, you
% use routine SET to get the best result.
%
%   Usage Examples,
%
%   circle([1,3],3,1000,':'); 
%   circle([2,4],2,1000,'--');
%
%   Zhenhai Wang <zhenhai@ieee.org>
%   Version 1.00
%   December, 2002
%---------------------------------------------------------------------------------------------
%Editted by Khai Sing -May 2011-


if (nargin <3),
 error('Please see help for INPUT DATA.');

end;


% Draw Macula circle
radius=Oriradius;
THETA=linspace(0,2*pi,NOP);
RHO=ones(1,NOP)*radius;
[Xm,Ym] = pol2cart(THETA,RHO);
Xm=Xm+center(1);
Ym=Ym+center(2);

X=Xm;
Y=Ym;

functionCall = @(hObject,eventdata)Annotation('mainFigure_ButtonDownFcn',hObject,eventdata,guidata(hObject));
p=plot(X,Y,'w-');
set(p,'ButtonDownFcn', functionCall );


end



