function handles = openFilesFromDirectory( directory, handles )
% get the folder from handles.filesDirectory, remove directories and populate the list box

% get dir information
dir_struct = dir(directory);

% copy names of files (not directories)
TMPnames = {dir_struct(~[dir_struct.isdir]).name}';

isImage = false(1, size(TMPnames, 1) );

for f = 1:size(TMPnames, 1)
    fileName = cell2mat(TMPnames(f));
    if size(fileName, 2) > 4 && ...
       (strcmp(fileName(end-3:end), '.jpg')  || ...
        strcmp(fileName(end-4:end), '.jpeg') || ...
        strcmp(fileName(end-3:end), '.png')  || ...
        strcmp(fileName(end-3:end), '.tif')  || ...
        strcmp(fileName(end-4:end), '.tiff') || ...
        strcmp(fileName(end-3:end), '.bmp')  || ...
        strcmp(fileName(end-3:end), '.ppm'))
    
            isImage(f) = true;
    end
end

handles.files.name = TMPnames(isImage);
handles.files.nFiles = sum(isImage);

% sotre folder path
handles.files.directory = directory;

% % initalize OD location (to false) for all images
% for f=1:handles.files.nFiles
% 
%     % set radius to 0 (meaning no lcoation)
%     handles.results(f).ODradius = 0;
% 
%     % arbitrary location
%     handles.results(f).ODcenter = [0 0];
% end
% 
% % save data
% guidata(handles.VAMPIRE,handles)

% print names in the list box
if handles.files.nFiles > 0
    set(handles.selectFiles_listbox, 'String', handles.files.name, 'Value', 1)
else
    set(handles.selectFiles_listbox, 'String', '-- No images found in this directory --');
end

% print directory in the text
set(handles.selectFiles_text, 'String', handles.files.directory)

% % update status text (that saves the handles structure)
% setStatus( handles, [num2str(handles.files.nFiles) ' images loaded from ' directory]);

