function showImage ( handles )

    imID = handles.imageID;
    
             

    % open image
    if imID > 0
        
        % show on main axes
        axes(handles.mainFigure)
        
        % clear axes
        cla;       
        
        set(handles.mainFigure, 'NextPlot', 'ReplaceChildren')
        
        % copy the call back
        functionCall = @(hObject,eventdata)Annotation('mainFigure_ButtonDownFcn',hObject,eventdata,guidata(hObject));
       

        % show image in handles
        p = imshow(handles.image); hold on;
           

        % set call back function (imshow rewrites it)
        set(p,'ButtonDownFcn', functionCall );

        % display which image is being annotated with respect to total images
        c=strcat('Image:',num2str(handles.imageID),'/',num2str(handles.files.nFiles));
        set(handles.display,'String',c);
        
        
             
    end
    
    % make sure axis are showing only the image and not further
    xAxis = get(handles.mainFigure, 'XLim');
    yAxis = get(handles.mainFigure, 'YLim');
        
    left = max(xAxis(1), 0);
    right = min(xAxis(2), handles.imW);
    bottom = max(yAxis(1), 0);
    top = min(yAxis(2), handles.imH);
    
    axis([left right bottom top]);
%     axis([0 handles.imW 0 handles.imH])

    

    % save data
    guidata( handles.output, handles )
    
    
    
        
    
    
    
    
    